/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TGENECATALOGDESC")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tgenecatalogdesc.findAll", query = "SELECT t FROM Tgenecatalogdesc t"),
    @NamedQuery(name = "Tgenecatalogdesc.findByCatalogcode", query = "SELECT t FROM Tgenecatalogdesc t WHERE t.tgenecatalogdescPK.catalogcode = :catalogcode"),
    @NamedQuery(name = "Tgenecatalogdesc.findByLanguagecode", query = "SELECT t FROM Tgenecatalogdesc t WHERE t.tgenecatalogdescPK.languagecode = :languagecode"),
    @NamedQuery(name = "Tgenecatalogdesc.findByRecordversion", query = "SELECT t FROM Tgenecatalogdesc t WHERE t.recordversion = :recordversion"),
    @NamedQuery(name = "Tgenecatalogdesc.findByDescription", query = "SELECT t FROM Tgenecatalogdesc t WHERE t.description = :description")})
public class Tgenecatalogdesc implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TgenecatalogdescPK tgenecatalogdescPK;
    @Column(name = "RECORDVERSION")
    private BigInteger recordversion;
    @Column(name = "DESCRIPTION")
    private String description;
    @JoinColumn(name = "CATALOGCODE", referencedColumnName = "CATALOGCODE", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tgenecatalog tgenecatalog;
    @JoinColumn(name = "LANGUAGECODE", referencedColumnName = "LANGUAGECODE", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tgenelanguage tgenelanguage;

    public Tgenecatalogdesc() {
    }

    public Tgenecatalogdesc(TgenecatalogdescPK tgenecatalogdescPK) {
        this.tgenecatalogdescPK = tgenecatalogdescPK;
    }

    public Tgenecatalogdesc(String catalogcode, String languagecode) {
        this.tgenecatalogdescPK = new TgenecatalogdescPK(catalogcode, languagecode);
    }

    public TgenecatalogdescPK getTgenecatalogdescPK() {
        return tgenecatalogdescPK;
    }

    public void setTgenecatalogdescPK(TgenecatalogdescPK tgenecatalogdescPK) {
        this.tgenecatalogdescPK = tgenecatalogdescPK;
    }

    public BigInteger getRecordversion() {
        return recordversion;
    }

    public void setRecordversion(BigInteger recordversion) {
        this.recordversion = recordversion;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Tgenecatalog getTgenecatalog() {
        return tgenecatalog;
    }

    public void setTgenecatalog(Tgenecatalog tgenecatalog) {
        this.tgenecatalog = tgenecatalog;
    }

    public Tgenelanguage getTgenelanguage() {
        return tgenelanguage;
    }

    public void setTgenelanguage(Tgenelanguage tgenelanguage) {
        this.tgenelanguage = tgenelanguage;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tgenecatalogdescPK != null ? tgenecatalogdescPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tgenecatalogdesc)) {
            return false;
        }
        Tgenecatalogdesc other = (Tgenecatalogdesc) object;
        if ((this.tgenecatalogdescPK == null && other.tgenecatalogdescPK != null) || (this.tgenecatalogdescPK != null && !this.tgenecatalogdescPK.equals(other.tgenecatalogdescPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tgenecatalogdesc[ tgenecatalogdescPK=" + tgenecatalogdescPK + " ]";
    }
    
}
